sub ambigious_based
{
$dir11=$dir1.'/ambiguous_filter_sequences_passed';
	$dir12=$dir1.'/ambiguous_filter_sequences_failed';
	make_path($dir11);
	make_path($dir12);
open(OUTFILE3,"> :raw","$dir11/sequences_passed_ambiguous_filter.fastq");
open(FAILED3,"> :raw","$dir12/sequences_failed_ambiguous_filter.fastq");
open(OUTFASTA1,"> :raw","$dir11/sequences_passed_length_filter.fasta");
open(OUTFASTA2,"> :raw","$dir12/sequences_failed_length_filter.fasta");
open(RESULT,"> :raw","$dir1/results.fastq");
$ambi_cutoff=$ambitxt;


for($ambi=0;$ambi<scalar(@infile);$ambi=$ambi+4)
{
	$line1=$infile[$ambi+1];
	chomp($line1);
	$ambi_count=0;
	for($seqlen=0;$seqlen<length($line1);$seqlen++)
	{
		if(substr($line1,$seqlen,1)=~/[ATGC]/)
		{
			$ambi_count++;   #total ATGC COUNT
		}
	}
	#print "aaa",length($line1),"\n";
	$ambigiousSeqCount=length($line1)-$ambi_count; # ambiguous base count
	$ambiPercent=(($ambigiousSeqCount*100)/length($line1)); # percentage of ambiguous bases in sequence
	#print "\n$ambiPercent----->$ambi_cutoff---->",length($line1);
	if(abs($ambiPercent)<=$ambi_cutoff) 
	{
	#	push( @infile_i3, $infile[$ambi].$infile[$ambi+1].$infile[$mbi+2].$infile[$mbi+3]);
		print OUTFILE3 $infile[$ambi];
		print OUTFILE3 $infile[$ambi+1];
		print OUTFILE3 $infile[$ambi+2];
		print OUTFILE3 $infile[$ambi+3];
		$id=$infile[$ambi];
		$id =~ s/^\@/>/;
	#	push(@infile_fasta3, $id.$infile[$ambi+1]); 
		print OUTFASTA1 "$id";
		print OUTFASTA1 $infile[$ambi+1];
		print RESULT $infile[$ambi];
		print RESULT $infile[$ambi+1];
		print RESULT $infile[$ambi+2];
		print RESULT $infile[$ambi+3];
		$sequences_passed3++;
		$total_seq3++;
	}
	else
	{
	#	push( @infile_f3, $infile[$ambi].$infile[$ambi+1].$infile[$ambi+2].$infile[$ambi+3]);
		print FAILED3 $infile[$ambi];
		print FAILED3 $infile[$ambi+1];
		print FAILED3 $infile[$ambi+2];
		print FAILED3 $infile[$ambi+3];
		$id=$infile[$ambi];
			$id =~ s/^\@/>/;
			print OUTFASTA2 "$id";
			print OUTFASTA2 $infile[$ambi+1];
	#	push(@infile_failed_fasta3, $id.$infile[$ambi+1]); 
		$sequences_failed3++;
		$total_seq3++;
	}
}
open(LOG,">>$dir1/log.txt")or die();
$time=localtime();
print LOG "\n$time : Sequences passed the Ambiguous filter\n";
print LOG "\n";
print LOG "------------------Input Parameter-------------------------------------\n";
print LOG "Ambiguous base Cut-off     :   $ambi_cutoff\n";
print LOG "----------Results after Ambiguous based cutoff-------------------------\n";
print LOG "sequences passed the filter : ".$sequences_passed3."\n";
print LOG "sequences failed the filter : ".$sequences_failed3."\n";
print LOG "total sequences             : ".$total_seq3."\n";
print LOG "-----------------------------------------------------------------------\n";

close (LOG);
close(OUTFILE3);
close(FAILED3);
close(RESULT);
	close(OUTFASTA1);
	close(OUTFASTA2);
}
return 1;