sub length_based
{
	$dir11=$dir1.'/length_filter_sequences_passed';
	$dir12=$dir1.'/length_filter_sequences_failed';
	make_path($dir11);
	make_path($dir12);
	open(LOG1,">>$dir1/log.txt")or die();
	
	
	open(OUTFILE2,"> :raw","$dir11/sequences_passed_length_filter.fastq");
	open(FAILED2,"> :raw","$dir12/sequences_failed_length_filter.fastq");
	open(OUTFASTA1,"> :raw","$dir11/sequences_passed_length_filter.fasta");
	open(OUTFASTA2,"> :raw","$dir12/sequences_failed_length_filter.fasta");
	open(RESULT,"> :raw","$dir1/results.fastq");
	$length_cutoff=$lentxt;
	
	#length of each reads are calculated and with the cutoff values sequences are filtered
	
	for($i=0;$i<scalar(@infile);$i=$i+4)
	{
		$count=0;
		$seqline=$infile[$i+1];
		$length_seq=length($seqline);
		if($length_seq>=$length_cutoff)
		{
			#push( @infile_i2, $infile[$i].$infile[$i+1].$infile[$i+2].$infile[$i+3]);
			print OUTFILE2 $infile[$i];
			print OUTFILE2 $infile[$i+1];
			print OUTFILE2 $infile[$i+2];
			print OUTFILE2 $infile[$i+3];
			$id=$infile[$i];
			$id =~ s/^\@/>/;
		#	push(@infile_fasta2, $id.$infile[$i+1]); 
			print OUTFASTA1 "$id";
			print OUTFASTA1 $infile[$i+1];
			print RESULT $infile[$i];
			print RESULT $infile[$i+1];
			print RESULT $infile[$i+2];
			print RESULT $infile[$i+3];
			$sequences_passed2++;
			$total_seq2++;
		}
		else
		{
		#	push( @infile_f2, $infile[$i].$infile[$i+1].$infile[$i+2].$infile[$i+3]);
			print FAILED2 $infile[$i];
			print FAILED2 $infile[$i+1];
			print FAILED2 $infile[$i+2];
			print FAILED2 $infile[$i+3];
			$id=$infile[$i];
			$id =~ s/^\@/>/;
			print OUTFASTA2 "$id";
			print OUTFASTA2 $infile[$i+1];
		#	push(@infile_failed_fasta2, $id.$infile[$i+1]); 
			$sequences_failed2++;
			$total_seq2++;
		}
	}
	#print RESULT @infile_i2; 
	#print OUTFILE @infile_i2;
	#print OUTFASTA1 @infile_fasta2;
	#print FAILED1 @infile_f2;
	#print OUTFASTA2 @infile_failed_fasta2;
	
	open(LOG,">>$dir1/log.txt")or die();
	$time=localtime();
	print LOG "\n$time : Sequences passed the length filter\n";
	print LOG "\n";
	print LOG "------------------Input Parameter-------------------------------------\n";
	print LOG "Length Cut-off Given       :   $length_cutoff\n";
	print LOG "----------Results after Length based cutoff----------------------------\n";
	print LOG "sequences passed the filter : ".$sequences_passed2."\n";
	print LOG "sequences failed the filter : ".$sequences_failed2."\n";
	print LOG "total sequences             : ".$total_seq2."\n";
	print LOG "------------------------------------------------------------------------";
	close (LOG);
	close(OUTFILE2);
	close(FAILED2);
	close(RESULT);
	close(OUTFASTA1);
	close(OUTFASTA2);
}

return 1;