#use List::Util qw(sum);
sub percentage
{
	$dir11=$dir1.'/quality_filter_sequences_passed';
	$dir12=$dir1.'/quality_filter_sequences_failed';
	make_path($dir11);
	make_path($dir12);
	open(LOG1,">>$dir1/log.txt")or die();
	
	#print $dir1;
	$c0to10=0;
	$c11to20=0;
	$c21to30=0;
	$c31to40=0;
	$c41to50=0;
	#print "$dir1/sequences_passed_quality_filter.fastq";
	open(OUTFILE,"> :raw","$dir11/sequences_passed_quality_filter.fastq")or die();
	open(FAILED1,"> :raw","$dir12/sequences_failed_quality_filter.fastq");
	open(OUTFASTA1,"> :raw","$dir11/sequences_passed_quality_filter.fasta");
	open(OUTFASTA2,"> :raw","$dir12/sequences_failed_quality_filter.fasta");
	open(RESULT,,"> :raw","$dir1/results.fastq");
	$quality=$val1;
	#print $dir1;
	$percentage=$val2;
	
	#print "\n$quality,$val1,$percentage,$val2";
	my @infile_i;
    my @infile_fasta;
	
	#Here,quality of each bases in each read are converted into quality values and compared with the user entered minimum quality value.
	#The number of bases below the user entered quality values are counted and the percentage is calculated. 
	
	for($i=0;$i<scalar(@infile);$i=$i+4)
	{
		$count=0;
		$line=$infile[$i+1];
		@seq1=();
		#@seqQ1=();
		for($j=0;$j<length($line);$j++)
		{
			$seq=substr($infile[$i+1],$j,1);
			$seqQ=substr($infile[$i+3],$j,1);
			$seqqval=ord($seqQ)-33;
			if($seqqval>=$quality)
			{
				$count++;
			}
			push(@seq1,$seq);
			#push(@seqQ1,$seqqval);
		}
	

		
		$percentage_count=($percentage*scalar(@seq1))/100;
		if($count>=abs($percentage_count))
		{
			
			#push( @infile_i, $infile[$i].$infile[$i+1].$infile[$i+2].$infile[$i+3]);
			print OUTFILE $infile[$i];
			print OUTFILE $infile[$i+1];
			print OUTFILE $infile[$i+2];
			print OUTFILE $infile[$i+3];
			print RESULT $infile[$i];
			$id=$infile[$i];
			$id =~ s/^\@/>/;
			#push(@infile_fasta, $id.$infile[$i+1]); 
			print OUTFASTA1 "$id";
			print OUTFASTA1 $infile[$i+1];
			print RESULT $infile[$i+1];
			print RESULT $infile[$i+2];
			print RESULT $infile[$i+3];
			$sequences_passed1++;
			$total_seq1++;
			
		}
		else
		{
			#push( @infile_f, $infile[$i].$infile[$i+1].$infile[$i+2].$infile[$i+3]);
			print FAILED1 $infile[$i],"\n";
			print FAILED1 $infile[$i+1],"\n";
			print FAILED1 $infile[$i+2],"\n";
			print FAILED1 $infile[$i+3],"\n";
			$id=$infile[$i];
			$id =~ s/^\@/>/;
			#push(@infile_failed_fasta, $id.$infile[$i+1]); 
			print OUTFASTA2 "$id";
			print OUTFASTA2 $infile[$i+1];
			$sequences_failed1++;
			$total_seq1++;
		}
		
	}
	#print RESULT @infile_i; 
	#print OUTFILE @infile_i;
	#print OUTFASTA1 @infile_fasta;
	#print FAILED1 @infile_f;
	#print OUTFASTA2 @infile_failed_fasta;
	
	my $time=localtime();
	print LOG1 "\n$time : Sequences passed the quality filter\n";
	print LOG1 "\n";
	print LOG1 "------------------Input Parameters-------------------------------------\n";
	print LOG1 "Quality Cut-off Given       :   $val1\n";
	print LOG1 "Percentage Cut-off Given    :   $val2\n";
	print LOG1 "---------------Results after quality cutoff----------------------------\n";
	print LOG1 "sequences passed the filter : ".$sequences_passed1."\n";
	print LOG1 "sequences failed the filter : ".$sequences_failed1."\n";
	print LOG1 "total sequences             : ".$total_seq1."\n";
	print LOG1 "------------------------------------------------------------------------";

	close (LOG1);
	close(OUTFILE);
	close(FAILED1);
	close(RESULT);
	close(OUTFASTA1);
	close(OUTFASTA2);
}			
return 1;		