sub pipeline
{

if($complete==1) # value 0 indicates they submitted wrong input
{
@stage=();
@seqFail=();
@seqPass=();
	open(FW,">$dir1/results.fastq");
	print FW @infile;
	close FW;
	$sequences_passed1=0;
	$sequences_failed1=0;
	$total_seq1=0;
	
	$sequences_passed2=0;
	$sequences_failed2=0;
	$total_seq2=0;
	
	$sequences_passed3=0;
	$sequences_failed3=0;
	$total_seq3=0;
	
	$sequences_passed4=0;
	$sequences_failed4=0;
	$total_seq4=0;
	$mw2 = MainWindow->new;
$mw2->resizable(0,0);
$mw2->geometry("500x500");
$nb2 = $mw2->NoteBook->pack (-fill => 'both', -expand => 1);
$calc3 = $nb2->add ('Results', -label => 'Results');
$fm_look = $calc3->Frame(-relief=>'groove',-borderwidth=>5);


$analysis=$fm_look->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-anchor=>'se',-expand=>0,-fill=>'x');
$frame3=$analysis->Frame(-relief=>'groove',-borderwidth=>0)->pack(-side=>'left',-anchor=>'se',-expand=>0,-fill=>'x');
$txt3=$analysis->Text(-height=>20,-width=>140)->pack(-side=>'left',-anchor=>'n',-expand=>0,-fill=>'both');
$seqtot=scalar(@infile);
if($flag==2)
{
	$val1 = $slide1->get();
	$val2 = $slide2->get();
	percentage();                                                         # call percentage() module in percentage_based.pm
		
		# results	
	$seqtotal=$total_seq1;
	$seq_pass=$sequences_passed1;
	$seq_fail=$sequences_failed1;
	$txt3->insert('0.0',"------------------------------------------------------------------------\n");
	$txt3->insert('0.0',"total sequences             : ".$seqtotal."\n");
	$txt3->insert('0.0',"sequences failed the filter : ".$seq_fail."\n");
	$txt3->insert('0.0',"sequences passed the filter : ".$seq_pass."\n");
	$txt3->insert('0.0',"----------------- Results after quantity filtering ---------------------\n");
#	$bar2->value( 20 );
	push(@stage,"Quality filter");
	#push(@seqGot,abs($total_seq1/$total_seq1));
	push(@seqPass,abs($sequences_passed1*4/$seqtot)*100);
	push(@seqFail,abs($sequences_failed1*4/$seqtot)*100);
}
open(INFILE,"< :raw","$dir1/results.fastq")or die();
@infile=<INFILE>;
close(INFILE);
#print @infile;
if($flag1==2)
{

	length_based();                                                         # calling length_based() in length_based.pm
	$seqtotal=$total_seq2;
	$seq_pass=$sequences_passed2;
	$seq_fail=$sequences_failed2;
	$txt3->insert('0.0',"------------------------------------------------------------------------\n");
	$txt3->insert('0.0',"total sequences             : ".$seqtotal."\n");
	$txt3->insert('0.0',"sequences failed the filter : ".$seq_fail."\n");
	$txt3->insert('0.0',"sequences passed the filter : ".$seq_pass."\n");
	$txt3->insert('0.0',"------------------ Results after length based filtering ----------------\n");
	push(@stage,"Length filter");
	#push(@seqGot,abs($total_seq2/$total_seq1));
	push(@seqPass,abs($sequences_passed2*4/$seqtot)*100);
	push(@seqFail,abs($sequences_failed2*4/$seqtot)*100);
}


open(INFILE,"< :raw","$dir1/results.fastq")or die();
@infile=<INFILE>;
close(INFILE);
#print scalar(@infile);
if($flag2==2)
{
	ambigious_based();                                                         # calling ambigious_based() in ambiguous_based.pm
	$seqtotal=$total_seq3;
	$seq_pass=$sequences_passed3;
	$seq_fail=$sequences_failed3;
	$txt3->insert('0.0',"------------------------------------------------------------------------\n");
	$txt3->insert('0.0',"total sequences             : ".$seqtotal."\n");
	$txt3->insert('0.0',"sequences failed the filter : ".$seq_fail."\n");
	$txt3->insert('0.0',"sequences passed the filter : ".$seq_pass."\n");
	$txt3->insert('0.0',"--------------- Results after ambigious based filtering ----------------\n");
	push(@stage,"Ambiguous filter");
	#push(@seqGot,abs($total_seq4/$total_seq1));
	push(@seqPass,abs($sequences_passed3*4/$seqtot)*100);
	push(@seqFail,abs($sequences_failed3*4/$seqtot)*100);
}

open(INFILE,"< :raw","$dir1/results.fastq");
@infile=<INFILE>;
close(INFILE);
if($flag3==2)
{

	homopolymer_based();                                                         # calling homopolymer_based() in homopolymer_based.pm
	$seqtotal=$total_seq4;
	$seq_pass=$sequences_passed4;
	$seq_fail=$sequences_failed4;
	$txt3->insert('0.0',"------------------------------------------------------------------------\n");
	$txt3->insert('0.0',"total sequences             : ".$seqtotal."\n");
	$txt3->insert('0.0',"sequences failed the filter : ".$seq_fail."\n");
	$txt3->insert('0.0',"sequences passed the filter : ".$seq_pass."\n");
	$txt3->insert('0.0',"------------------ Results after homopolymer based filtering ------------\n");
#	$bar2->value( 80 );
	push(@stage,"Homopolymer filter");
	#push(@seqGot,abs($total_seq4/$total_seq1));
	push(@seqPass,abs($sequences_passed4*4/$seqtot)*100);
	push(@seqFail,abs($sequences_failed4*4/$seqtot)*100);
}
$nb2->pageconfigure('Results',-state=>'normal');
$nb2->raise('Results');
unlink("$dir1/results.fastq");
$fm_look->pack(-side=>'top',-expand=>0,-fill=>'x');


################################################ graph after pipeline ###################

$data1 = GD::Graph::Data->new([
    
    [@stage],
	[@seqPass],[@seqFail]])or die GD::Graph::Data->error;

	$graph = GD::Graph::bars->new(500,500);

	$graph->set( 
	title      => 'EC-QC Filter Results',
    x_label     => 'Filters',
    y_label     => '% of sequences',
	bar_spacing => 1,
	bar_width   => 20,
#	shadowclr => 'dred',
	transparent => 0,
	dclrs       => ['#3366ff', '#ff9900']
	) or die $graph->error;
	
	$graph->set_legend_font(GD::gdMediumBoldFont);
	$graph->set_legend('Passed', 'Failed');
	$graph->plot($data1) or die $graph->error;

	my $file = "$dir1/ECQC_Results.gif";
	#print $file;
	open(my $out, '> :raw', $file) or die "Cannot open '$file' for write: $!";
	binmode $out;
	print $out $graph->gd->gif;
	close $out;
	$nb2->pageconfigure('Results',-state=>'normal');
	$nb2->raise('Results');
	$chartlabframe=$calc3->LabFrame(-label=>"ECQC results",-foreground=>"red",-font=>[-size=>'10'])->pack(-anchor=>'nw',-ipadx=>8,-ipady=>8);
	$linechart=$chartlabframe->Button(-text=>"    ECQC_Results        ",-font=>[-size =>'10'], -height => 1,-command=>\&ecqcresults)->pack(-side=>"left",-anchor=>'n');
	
	}
}

sub ecqcresults
{
	$ecqcg = MainWindow->new(
    -title      => 'ecqc results',
    -background => 'white',
  );
  $ecqcg->geometry("520x520");
  print "$dir1";
 $image4 = $ecqcg->Photo(-file => "$dir1/ECQC_Results.gif");
$ecqcg->Button(-image => $image4)->pack(-anchor=>"center");

}
mainloop;	