sub homopolymer_based
{
$dir11=$dir1.'/homoplymer_filter_sequences_passed';
	$dir12=$dir1.'/homopolymer_filter_sequences_failed';
	make_path($dir11);
	make_path($dir12);
open(OUTFILE4,"> :raw","$dir11/sequences_passed_homopolymer_based_filter.fastq");
open(FAILED4,"> :raw","$dir12/sequences_failed_homopolymer_based_filter.fastq");
	open(OUTFASTA1,"> :raw","$dir11/sequences_passed_length_filter.fasta");
	open(OUTFASTA2,"> :raw","$dir12/sequences_failed_length_filter.fasta");
open(RESULT,"> :raw","$dir1/results.fastq");
$check=0;
$homo_cutoff=$homotxt;


for($homline=0;$homline<scalar(@infile);$homline=$homline+4)
{
	$count=1;
	$check=0;
	$line=$infile[$homline+1];
	chomp($line);
			
	for($seq=0;$seq<length($line);$seq++)
	{
		$base=substr($line,$seq,1);
		$nxtbase=substr($line,$seq+1,1);
		if($base eq $nxtbase) #checking first base and second base are equal
		{
			$count++; #incremanting the count value
			if($count>=$homo_cutoff) #count exceed the homo_cutoff, it fails so $check=1 results failed sequence
			{
				$check=1;
				last;
			}
		}
		else
		{
			$count=1;
		}
	}
	
	if($check==0)
	{
	#	push( @infile_i4, $infile[$homline].$infile[$homline+1].$infile[$homline+2].$infile[$homline+3]);
		print OUTFILE4 $infile[$homline];
		print OUTFILE4 $infile[$homline+1];
		print OUTFILE4 $infile[$homline+2];
		print OUTFILE4 $infile[$homline+3];
					$id=$infile[$homline];
			$id =~ s/^\@/>/;
			print OUTFASTA1 "$id";
			print OUTFASTA1 $infile[$i+1];
	#	push(@infile_fasta4, $id.$infile[$homliine+1]); 
		print RESULT $infile[$homline];
		print RESULT $infile[$homline+1];
		print RESULT $infile[$homline+2];
		print RESULT $infile[$homline+3];
		$sequences_passed4++;
		$total_seq4++;
	}
	else
	{
	#	push( @infile_f3, $infile[$homline].$infile[$homline+1].$infile[$homline+2].$infile[$homline+3]);
		print FAILED4 $infile[$homline];
		print FAILED4 $infile[$homline+1];
		print FAILED4 $infile[$homline+2];
		print FAILED4 $infile[$homline+3];
		$id=$infile[$homline];
			$id =~ s/^\@/>/;
	#	push(@infile_failed_fasta3, $id.$infile[$homline+1]); 
			print OUTFASTA2 "$id";
			print OUTFASTA2 $infile[$homline+1];
		$sequences_failed4++;
		$total_seq4++;
	}
}
open(LOG,">>$dir1/log.txt")or die();
$time=localtime();
print LOG "\n$time : Sequences passed the homopolymer filter\n";
print LOG "\n";
print LOG "------------------Input Parameters--------------------------------------\n";
print LOG "Homopolymer Cut-off Given  :   $homo_cutoff\n";
print LOG "----------Results after homopolymer based cutoff------------------------\n";
print LOG "sequences passed the filter : ".$sequences_passed4."\n";
print LOG "sequences failed the filter : ".$sequences_failed4."\n";
print LOG "total sequences             : ".$total_seq4."\n";
print LOG "------------------------------------------------------------------------";

close (LOG);
close(OUTFILE4);
close(FAILED4);
close(RESULT);
	close(OUTFASTA1);
	close(OUTFASTA2);
}
return 1;